#include <stdio.h>
#include "Mapa.h"

//----------------------------------------------------------------
// Tipus Bilbo & Smaug
//----------------------------------------------------------------
struct Bilbo
{
    Coordenades coords;
    bool te_joia;
};

struct Smaug
{
    Coordenades coords;
    int profunditat_somni;
};

//----------------------------------------------------------------
// Ops Bilbo
//----------------------------------------------------------------
void InicialitzarBilbo( const Mapa& m, Bilbo& b )
{
	//COMPLETAR: Inicialitzar Bilbo

	// te_joia == false;
	b.coords = BuscarMapa( m, '@' ); // Determinem les coordenades del mapa inicial on est en Bilbo representat per l'arroba
}

void PrintBilbo( const Bilbo& b )
{
    printf( "Bilbo: Coords = (%d,%d), Joia = %d\n", b.coords.i, b.coords.j, (int)b.te_joia );
}

void TornBilbo( Mapa &m, Bilbo& b, Smaug& s )
{
    //COMPLETAR: Moure Bilbo i Actualitzar Tauler
	
	if ( b.te_joia == true )
	{
		BuscarMapa( m, '<' );
		b.coords = Coordenades_FerUnPas( b.coords, m.coords_sortida );
		ModificarMapa( m, b.coords.i, b.coords.j, '@' );
		if ( ConsultarMapa( m, b.coords.i, b.coords.j ) == '%' ) // Si Bilbo trepitja un esquelet, Smaug es desvetlla
		{
			s.profunditat_somni = s.profunditat_somni-2;
		}
		else if( ConsultarMapa( m, b.coords.i, b.coords.j ) == '$' ) // Si Bilbo trepitja un esquelet, Smaug es desvetlla moderadament
		{
			s.profunditat_somni = s.profunditat_somni-1;
		}
	}
	else
	{
		BuscarMapa( m, '*' );
		b.coords = Coordenades_FerUnPas( b.coords, m.coords_joia );
		ModificarMapa( m, b.coords.i, b.coords.j, '@' );
		if ( ConsultarMapa( m, b.coords.i, b.coords.j ) == '%' ) // Si Bilbo trepitja un esquelet, Smaug es desvetlla
		{
			s.profunditat_somni = s.profunditat_somni-2;
		}
		else if( ConsultarMapa( m, b.coords.i, b.coords.j ) == '$' ) // Si Bilbo trepitja un esquelet, Smaug es desvetlla moderadament
		{
			s.profunditat_somni = s.profunditat_somni-1;
		}
	}
	
	/*
	switch (b.coords) {
		case '@': break;
		case 'D': break;
		default:
			;
	*/
}

//----------------------------------------------------------------
// Ops Smaug
//----------------------------------------------------------------
void InicialitzarSmaug( const Mapa& m, Smaug& s, int profunditat_somni )
{
    //COMPLETAR: Inicialitzar Smaug

	s.profunditat_somni = profunditat_somni; // Inicialitzem la variable que comprn la profunditat del somni d'Smaug
	s.coords = BuscarMapa( m, 'D' ); // Determinem les coordenades del mapa inicial on est Smaug representat per la "D"
}

void PrintSmaug( const Smaug& s )
{
    printf( "Smaug: Coords = (%d,%d), Somni = %d\n", s.coords.i, s.coords.j, s.profunditat_somni );
}

void TornSmaug( Mapa &m, const Bilbo& b, Smaug& s )
{
    //COMPLETAR: Moure Smaug i Actualitzar Tauler
	if ( s.profunditat_somni <= 0 ) // Si Smaug s'ha despertat
	{                        
		BuscarMapa( m, '@' ); // Buscar a en Bilbo
		s.coords = Coordenades_FerUnPas( s.coords, b.coords );
		ModificarMapa( m, s.coords.i, s.coords.j, 'D' );
	}
}

int ExecutarTorns( Mapa &mapa, Bilbo& bilbo, Smaug& smaug )
{
    //COMPLETAR: Mentre partida no acabi, Executar Torns Bilbo i Smaug i Comprovar si partida ha acabat, calculant el resultat adient
   	int resultat= -1;
	while ( resultat == -1 )
	{
		TornBilbo( mapa, bilbo, smaug );
		TornSmaug( mapa, bilbo, smaug );
		if ( Coordenades_Igual( bilbo.coords, smaug.coords ) )
		{
			resultat= 0;
			return resultat;  
		}
		else if ( Coordenades_Igual( bilbo.coords, mapa.coords_sortida )) 
		{ 
			if ( bilbo.te_joia == true )
			{
				resultat= 1;
				return resultat;  
			}
			else
			{
				resultat= 2;
				return resultat;  
				
			}
		}
		int resultat= -1;
	}
}

//----------------------------------------------------------------
// Main
//----------------------------------------------------------------
int main()
{
    // Inicialitzaci
    printf("\nInicialitzant...\n");

    int files = ReadInteger();
    int columnes = ReadInteger();
    int profunditat_somni = ReadInteger();

    Mapa mapa;
    InicialitzarMapa( mapa, files, columnes );
    LlegirMapa( mapa );
    PrintMapa( mapa );

    Bilbo bilbo;
    InicialitzarBilbo( mapa, bilbo );
    PrintBilbo( bilbo );

    Smaug smaug;
    InicialitzarSmaug( mapa, smaug, profunditat_somni );
    PrintSmaug( smaug );

    // Actualitzaci
    printf("\nExecutant torns...\n");
    int resultat = ExecutarTorns( mapa, bilbo, smaug );

    // Resultats
    printf("\nResultats\n");
    PrintMapa( mapa );
    PrintBilbo( bilbo );
    PrintSmaug( smaug );
    switch( resultat )
    {
		case 0: printf("Smaug devora Bilbo\n"); break;
		case 1: printf("Bilbo escapa amb la Joia\n"); break;
		case 2: printf("Bilbo escapa sense la Joia\n"); break;
		default: printf("RESULTAT INCORRECTE\n"); break;
    }

    // Alliberar memria
    DestruirMapa( mapa );

    // Return correct
    return 0;
}
